% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Ph.D. Course "Cognitive CPSs: from theory to practice"
% Prof. Manuel Roveri, Prof. Cesare Alippi
% Politecnico di Milano, Italy
% March 2016
% 
% ----- "Uncertainty, Information and Learning Mechanisms - Part 1"
% -> Example 3_2_C) Nonlinear Dataset - Linear Model
%
% % Modify the number of points and the std of the noise
%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
clc;
close all;
addpath('./functions');


%Number of points used for training
N = 50;

%Noise standard deviation
std_dev = 0.05;

%Training data generation
Xt = 4*rand(1,N)-2; %uniform samples on [-2;2]
noise = std_dev * randn(1,N);
Yt = nonlin_fun(Xt,noise);


%% Network training

% Initializing network
neural_net = fitnet(1);

%Setting network parameters
neural_net.layers{1}.transferFcn = 'purelin'; %linear activation function for hidden layer

%Training network
neural_net = train(neural_net,Xt,Yt);


%% Plotting results
plot_nn_regression(@nonlin_fun,neural_net,Xt,Yt);
