function y = nonlin_fun_biased(x,eta)
% y = nonlin_fun_biased(x,eta)
% input: x = independent variable for the function
%        eta = standard deviation of the noise to be inserted in computation
% output: y = evaluation of the function with gaussian noise

if nargin == 1
    [m,n] = size(x);
    eta = randn(m,n)*0.001;
end
y = -x .* sin(x.^2) + (exp(-0.23.*x)./(1 + x.^4)) + 1 + eta;
